/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.Isolines;

import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.jscic.CellSet;
import org.visnow.jscic.Field;
import org.visnow.jscic.IrregularField;
import org.visnow.jscic.RegularField;
import org.visnow.jscic.dataarrays.DataArray;
import org.visnow.vn.lib.types.VNField;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class IsolinesGUI extends JPanel
{

    private static final long serialVersionUID = 5643139078298589324L;
    private Field inField = null;
    private IsolinesParams params = new IsolinesParams();
    private String oldComponentName = "";
    private boolean[] aCS = null;
    private float vMin = 0, vMax = 255, 
                  oldMin = Float.NEGATIVE_INFINITY, oldMax = Float.POSITIVE_INFINITY;
    private float physMin = 0, physMax = 255,
                  oldPhysMin = Float.NEGATIVE_INFINITY, oldPhysMax = Float.POSITIVE_INFINITY;
    private boolean syncing = false;

    /**
     * Creates new form IsolinesUI
     */
    public IsolinesGUI()
    {
        initComponents();
        isoComponentSelector.setTitle("isoline component");
        thresholdsEditor.setMaxRangeCount(2);
        thresholdsEditor.setStartSingle(false);
        thresholdsEditor.setValuePreferred(false);
        thresholdsEditor.addChangeListener(new ChangeListener()
        {
            @Override
            public void stateChanged(ChangeEvent e)
            {
                params.setThresholds(thresholdsEditor.getThresholds());
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        isoComponentSelector = new org.visnow.vn.lib.gui.DataComponentSelector();
        cellSetScrollPane = new javax.swing.JScrollPane();
        cellSetList = new javax.swing.JList();
        thresholdsEditor = new org.visnow.vn.lib.gui.FloatArrayEditor();
        jPanel1 = new javax.swing.JPanel();
        estimateQualityBox = new javax.swing.JCheckBox();
        bdrCheckBox = new javax.swing.JCheckBox();

        setLayout(new java.awt.GridBagLayout());

        isoComponentSelector.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        isoComponentSelector.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                isoComponentSelectorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(isoComponentSelector, gridBagConstraints);

        cellSetScrollPane.setMinimumSize(new java.awt.Dimension(50, 60));
        cellSetScrollPane.setPreferredSize(new java.awt.Dimension(50, 100));

        cellSetList.setEnabled(false);
        cellSetList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                cellSetListValueChanged(evt);
            }
        });
        cellSetScrollPane.setViewportView(cellSetList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(cellSetScrollPane, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(thresholdsEditor, gridBagConstraints);

        jPanel1.setLayout(new java.awt.BorderLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        estimateQualityBox.setText("estimate isoline quality");
        estimateQualityBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                estimateQualityBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(estimateQualityBox, gridBagConstraints);

        bdrCheckBox.setText("draw isolines on boundaries");
        bdrCheckBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                bdrCheckBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(bdrCheckBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void cellSetListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_cellSetListValueChanged
    {//GEN-HEADEREND:event_cellSetListValueChanged
        if (aCS != null)
            for (int i = 0; i < aCS.length; i++)
                aCS[i] = cellSetList.isSelectedIndex(i);
        params.setActiveCellSets(aCS);
    }//GEN-LAST:event_cellSetListValueChanged

    private void isoComponentSelectorStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_isoComponentSelectorStateChanged
        if (syncing)
            return;
        syncing = true;
        boolean oldActive = params.isActive();
        params.setActive(false);
        int k = isoComponentSelector.getComponent();
        params.setComponent(k);
        if (k != -1)
            setDataComponent(k);
        params.setActive(oldActive);
        syncing = false;
    }//GEN-LAST:event_isoComponentSelectorStateChanged

    private void estimateQualityBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_estimateQualityBoxActionPerformed
        params.setEstimateQuality(estimateQualityBox.isSelected());
    }//GEN-LAST:event_estimateQualityBoxActionPerformed

    private void bdrCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_bdrCheckBoxActionPerformed
    {//GEN-HEADEREND:event_bdrCheckBoxActionPerformed
        params.setDrawOnBoundary(bdrCheckBox.isSelected());
    }//GEN-LAST:event_bdrCheckBoxActionPerformed

    private void setDataComponent(int k)
    {
        DataArray da = inField.getComponent(k);
        vMin = (float)da.getPreferredMinValue();
        vMax = (float)da.getPreferredMaxValue();
        physMin = (float)da.getPreferredPhysMinValue();
        physMax = (float)da.getPreferredPhysMaxValue();
        if (da.getName().equals(oldComponentName) &&
            vMin    == oldMin     && vMax    == oldMax &&
            physMin == oldPhysMin && physMax == oldPhysMax)
            return;
        oldMin = vMin;
        oldMax = vMax;
        oldPhysMin = physMin;
        oldPhysMax = physMax;
        oldComponentName = da.getName();
        thresholdsEditor.setMinMax(vMin, vMax, physMin, physMax);
    }

    /**
     * Setter for property inField.
     *
     * @param in New value of property inField.
     */
    public void setInField(VNField in)
    {
        params.setActive(false);
        Field inFld = in.getField();
        boolean hasCells3D = false;
        if (inFld instanceof RegularField)
            hasCells3D = ((RegularField)inFld).getDimNum() == 3;
        else 
            hasCells3D = ((IrregularField)inFld).hasCells3D();
        estimateQualityBox.setEnabled(inFld instanceof RegularField && ((RegularField)inFld).getDimNum() == 2);
        bdrCheckBox.setEnabled(hasCells3D);
        if (inFld instanceof RegularField &&
            (((RegularField) inFld).getDims() == null ||
            ((RegularField) inFld).getDims().length < 2))
            return;
        if (inField == null || !inField.isDataCompatibleWith(inFld)) {
            inField = inFld;
            isoComponentSelector.setDataSchema(inFld.getSchema());
            isoComponentSelector.setSelectedIndex(0);
        }
        if (inField instanceof IrregularField) {
            String[] cellSetNames = new String[((IrregularField) inFld).getNCellSets()];
            aCS = new boolean[((IrregularField) inFld).getNCellSets()];
            int[] indices = new int[((IrregularField) inFld).getNCellSets()];
            for (int i = 0; i < cellSetNames.length; i++) {
                cellSetNames[i] = ((IrregularField) inFld).getCellSet(i).getName();
                indices[i] = i;
                aCS[i] = true;
            }
            cellSetList.setListData(cellSetNames);
            cellSetList.setSelectedIndices(indices);
            params.setActiveCellSets(aCS);
        } 
        cellSetList.setVisible(inField instanceof IrregularField);
        setDataComponent(isoComponentSelector.getComponent());
        params.setActive(true);
    }

    public void setParams(IsolinesParams params)
    {
        this.params = params;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JCheckBox bdrCheckBox;
    public javax.swing.JList cellSetList;
    public javax.swing.JScrollPane cellSetScrollPane;
    public javax.swing.JCheckBox estimateQualityBox;
    public org.visnow.vn.lib.gui.DataComponentSelector isoComponentSelector;
    public javax.swing.JPanel jPanel1;
    public org.visnow.vn.lib.gui.FloatArrayEditor thresholdsEditor;
    // End of variables declaration//GEN-END:variables
}
